#include "uart-gpio.hpp"

using namespace stm32f072xb;

UartGpio<UartRegister::UART1, UartGpioType::TX, Port::A>::UartGpio()
    : AlternateGpio<Port::A>({GpioPin::P9, Pupdr::NONE, AlternateFunction::AF1}) {}

UartGpio<UartRegister::UART1, UartGpioType::RX, Port::A>::UartGpio()
    : AlternateGpio<Port::A>({GpioPin::P10, Pupdr::NONE, AlternateFunction::AF1}) {}

UartGpio<UartRegister::UART1, UartGpioType::TX, Port::B>::UartGpio()
    : AlternateGpio<Port::B>({GpioPin::P6, Pupdr::NONE, AlternateFunction::AF0}) {}

UartGpio<UartRegister::UART1, UartGpioType::RX, Port::B>::UartGpio()
    : AlternateGpio<Port::B>({GpioPin::P7, Pupdr::NONE, AlternateFunction::AF0}) {}

UartGpio<UartRegister::UART2, UartGpioType::TX, Port::A>::UartGpio()
    : AlternateGpio<Port::A>({GpioPin::P2, Pupdr::NONE, AlternateFunction::AF1}) {}

UartGpio<UartRegister::UART2, UartGpioType::RX, Port::A>::UartGpio()
    : AlternateGpio<Port::A>({GpioPin::P3, Pupdr::NONE, AlternateFunction::AF1}) {}

UartGpio<UartRegister::UART2, UartGpioType::TX, Port::D>::UartGpio()
    : AlternateGpio<Port::D>({GpioPin::P5, Pupdr::NONE, AlternateFunction::AF0}) {}

UartGpio<UartRegister::UART2, UartGpioType::RX, Port::D>::UartGpio()
    : AlternateGpio<Port::D>({GpioPin::P6, Pupdr::NONE, AlternateFunction::AF0}) {}

UartGpio<UartRegister::UART3, UartGpioType::TX, Port::B>::UartGpio()
    : AlternateGpio<Port::B>({GpioPin::P10, Pupdr::NONE, AlternateFunction::AF4}) {}

UartGpio<UartRegister::UART3, UartGpioType::RX, Port::B>::UartGpio()
    : AlternateGpio<Port::B>({GpioPin::P11, Pupdr::NONE, AlternateFunction::AF4}) {}

UartGpio<UartRegister::UART3, UartGpioType::TX, Port::C>::UartGpio()
    : AlternateGpio<Port::C>({GpioPin::P4, Pupdr::NONE, AlternateFunction::AF1}) {}

UartGpio<UartRegister::UART3, UartGpioType::RX, Port::C>::UartGpio()
    : AlternateGpio<Port::C>({GpioPin::P5, Pupdr::NONE, AlternateFunction::AF1}) {}

UartGpio<UartRegister::UART3, UartGpioType::TX, Port::D>::UartGpio()
    : AlternateGpio<Port::D>({GpioPin::P8, Pupdr::NONE, AlternateFunction::AF0}) {}

UartGpio<UartRegister::UART3, UartGpioType::RX, Port::D>::UartGpio()
    : AlternateGpio<Port::D>({GpioPin::P9, Pupdr::NONE, AlternateFunction::AF0}) {}

UartGpio<UartRegister::UART4, UartGpioType::TX, Port::A>::UartGpio()
    : AlternateGpio<Port::A>({GpioPin::P0, Pupdr::NONE, AlternateFunction::AF4}) {}

UartGpio<UartRegister::UART4, UartGpioType::RX, Port::A>::UartGpio()
    : AlternateGpio<Port::A>({GpioPin::P1, Pupdr::NONE, AlternateFunction::AF4}) {}

UartGpio<UartRegister::UART4, UartGpioType::TX, Port::C>::UartGpio()
    : AlternateGpio<Port::C>({GpioPin::P10, Pupdr::NONE, AlternateFunction::AF0}) {}

UartGpio<UartRegister::UART4, UartGpioType::RX, Port::C>::UartGpio()
    : AlternateGpio<Port::C>({GpioPin::P11, Pupdr::NONE, AlternateFunction::AF0}) {}
